/* 
 * LiulGuph.h -- Interface file for the LiulGuph class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to its
 * fitness for any particular use.
 *
 */

#import <appkit/appkit.h>
#import <appkit/NXCType.h>

@interface LiulGuph:View
{

	id		gen2;
	id		gen3;
	id		gen4;
	id		gen5;
	id		gen6;
	id		gen7;

	id		treeShow;

	id		dbBranches;
	id		dbView;
	id		dbWindow;
	id		evWindow;
	id		evButton;
	id		linkAge;
	id		moveWhich;
	id		nodeNumber;
	id		ruleNumber;
	id		underDiagram;
	id		whichConstant;
	id		whichPermutation;
	id		whichShift;

	id		sparePanel;
	id		spareView;
	id		timeDate;
	id		wholePanel;
	
	id		delegate;
	id		crossCursor;
}

- basicRijn:sender;
- printBasic:sender;
- printGeneric:sender;
- rijn:sender;
- rijnRanSam:sender;
- printRijn:sender;
- shewRijn:sender;
- showRijn:sender;
- rijnConst:sender;
- rijnHowBig:sender;
- rijnReset:sender;
- Zot:sender;


- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- mouseDown:(NXEvent *)theEvent;
- awake;
- (const char *)inspectorName;
@end

/* end LiulGuph.h */
