   
#import "RulePanel.h"
#import "nxlcau5t.h"
#import <string.h>
#import <time.h>
#import "rec.h"

extern char arule[DS], arr1[AL], arr2[AL], arr3[AL];
extern  int binrule[KK][KK][KK][KK];
extern int    co, dn;			/* connectivity, dimension */
extern char ascrule[KK][KK][KK][KK];
extern char auxrule[KK][KK][KK][KK];
       char gf5rule[13];		/* coefficients of GF5 rule	*/
extern char ttrule[TS];
extern char tarule[TS];
extern char strule[KK+1][SS-1];

void    asctobin();
void	asczero();
void	auxzero();
void    chrucopy(char ii[KK][KK][KK][KK],
	         char jj[KK][KK][KK][KK],
	         int c);
void    clumin(char *c);
int     cyy(int i);
int     fli(int i);
void    gftoasc();
void    gfzero();
void 	granprule();
void 	granrule();
int     istot();
int     isstot();
void    oxtoasc(char *r);
int     permut(int k, int n);
void    ptedbrul(birular *pr, birular *br, int k);
void    putionj(int i, int j);
int     ran2of3(int a, int b);
int     ran3of3(int a, int b, int c);
void    ranblin(double p0, double p1, double p2, double p3, double p4);
void    ranvachrul(char *c);
void    rule5t();
void	sttoasc();
void    stzero();
void	totoasc();
int     totonu(int i);
void    ttzero();
void 	defineWrule(long int WW);
void    wrru(char *c, char ru[KK][KK][KK][KK]);
void	xtoasc(int n);

extern int rec_c(char *z, Inst rprg, int l, struct fptbl dtbl[]);
int     ycc(int i);


void bincopy(birular *rz, int rx[KK][KK][KK][KK]);
void binprint(birular rz);
void binprod(birular *rz, birular rx, birular ry);
void binsum(birular *rz, birular rx, birular ry);
void bintoasc();

void auxiliar(birular *first,int *second);
void llena_matriz(birular rx,birular ry);
void espera(void); 

int permu[RSYM/2][KK] = {
        {0,1,2,3,4},
        {1,2,3,4,0},
        {2,3,4,0,1},
        {3,4,0,1,2},
        {4,0,1,2,3},
        {0,2,3,4,1},
        {0,3,4,1,2},
        {0,4,1,2,3},      
        {1,3,4,0,2},
        {1,4,0,2,3},
        {1,0,2,3,4},
        {2,4,0,1,3},
        {2,0,1,3,4},
        {2,1,3,4,0},
        {3,0,1,2,4},
        {3,1,2,4,0},
        {3,2,4,0,1},
        {4,1,2,3,0},
        {4,2,3,0,1},
        {4,3,0,1,2},
        {0,1,3,4,2},
        {0,1,4,2,3},
        {1,2,4,0,3},
        {1,2,0,3,4},
        {2,3,0,1,4},
        {2,3,1,4,0},
        {3,4,1,2,0},
        {3,4,2,0,1},
        {4,0,2,3,1},
        {4,0,3,1,2},
        {0,2,4,1,3},
        {0,2,1,3,4},
        {0,3,1,2,4},
        {0,3,2,4,1},
        {0,4,2,3,1},
        {0,4,3,1,2},
        {1,3,0,2,4},
        {1,3,2,4,0},
        {1,4,2,3,0},
        {1,4,3,0,2},
        {1,0,3,4,2},
        {1,0,4,2,3},
        {2,4,1,3,0},
        {2,4,3,0,1},
        {2,0,3,4,1},
        {2,0,4,1,3},
        {2,1,4,0,3},
        {2,1,0,3,4},
        {3,0,2,4,1},
        {3,0,4,1,2},
        {3,1,4,0,2},
        {3,1,0,2,4},
        {3,2,0,1,4},
        {3,2,1,4,0},
        {4,1,3,0,2},
        {4,1,0,2,3},
        {4,2,0,1,3},
        {4,2,1,3,0},
        {4,3,1,2,0},
        {4,3,2,0,1},
        {0,1,2,4,3},
        {1,2,3,0,4},
        {2,3,4,1,0},
        {3,4,0,2,1},
        {4,0,1,3,2},
        {0,2,3,1,4},
        {0,3,4,2,1},
        {0,4,1,3,2},   
        {1,3,4,2,0},
        {1,4,0,3,2},
        {1,0,2,4,3},
        {2,4,0,3,1},
        {2,0,1,4,3},
        {2,1,3,0,4},
        {3,0,1,4,2},
        {3,1,2,0,4},
        {3,2,4,1,0},
        {4,1,2,0,3},
        {4,2,3,1,0},
        {4,3,0,2,1},
        {0,1,3,2,4},
        {0,1,4,3,2},
        {1,2,4,3,0},
        {1,2,0,4,3},
        {2,3,0,4,1},
        {2,3,1,0,4},
        {3,4,1,0,2},
        {3,4,2,1,0},
        {4,0,2,1,3},
        {4,0,3,2,1},
        {0,2,4,3,1},
        {0,2,1,4,3},
        {0,3,1,4,2},
        {0,3,2,1,4},
        {0,4,2,1,3},
        {0,4,3,2,1},
        {1,3,0,4,2},
        {1,3,2,0,4},
        {1,4,2,0,3},
        {1,4,3,2,0},
        {1,0,3,2,4},
        {1,0,4,3,2},
        {2,4,1,0,3},
        {2,4,3,1,0},
        {2,0,3,1,4},
        {2,0,4,3,1},
        {2,1,4,3,0},
        {2,1,0,4,3},
        {3,0,2,1,4},
        {3,0,4,2,1},
        {3,1,4,2,0},
        {3,1,0,4,2},
        {3,2,0,4,1},
        {3,2,1,0,4},
        {4,1,3,2,0},
        {4,1,0,3,2},
        {4,2,0,3,1},
        {4,2,1,0,3},
        {4,3,1,0,2},
        {4,3,2,1,0}};

char    xr[DS] = "0011001100110011";
char    xp[DS] = "1333333333333332";
char    xq[DS] = "2122112211221121";

int aritmetic=0;

extern struct 	fptbl dtbl[];
extern Inst 	xprg[][XLEN];
extern char	idef[][30];

int vecperm(int ii[KK], int n);
int allperm(char wn[][WNML],
	    char ii[][KK][KK][KK][KK],
	    char ru[KK][KK][KK][KK]);
int longwolftoasc(char *c);
void numtobin2h(long int ru[KK][KK],long int  n);


@implementation RulePanel

/* - - - - - S P E C I A L   R U L E   B O X   M A N A G E M E N T - - - - - */

- loadSpecialRule:sender {char *ch;
  ch=[[sender selectedCell] title];
printf("loadSpecialRule: title = %s\n",ch);
  if (strcmp(ch,"appIcon")==0)     [self loadLowerPanel: [NXApp appIcon]];
  if (strcmp(ch,"arithmetic")==0)  [self loadLowerPanel: arithmRuleBox];
//   if (strcmp(ch,"composite")==0)   [self loadLowerPanel: compRuleBox];
  if (strcmp(ch,"equivalence")==0) [self loadLowerPanel: equivRuleBox];
//   if (strcmp(ch,"product")==0)     [self loadLowerPanel: prodRuleBox];
  if (strcmp(ch,"miscellaneous")==0)      [self loadLowerPanel: miscRuleBox];
  if (strcmp(ch,"subset")==0)      [self loadLowerPanel: subsetRuleBox];
//   if (strcmp(ch,"reversible")==0)  [self loadLowerPanel: fredknRuleBox];
return self;
}

- loadLowerPanel:thisRuleBox {NXRect bxRect, loRect;
 id cv;
 cv=[thisRuleBox contentView];
printf("thisRuleBox title = %d\n",[[cv subviews] count]);
  [specBigBox getFrame: &bxRect];
  [thisRuleBox getFrame: &loRect];
  [specLilBox setContentView: cv];
  loRect.origin.x=bxRect.origin.x+(bxRect.size.width-loRect.size.width)/2.0;
  loRect.origin.y=bxRect.origin.y+(bxRect.size.height-loRect.size.height)/2.0;
  [specLilBox setFrame: &loRect];
  [specBigBox display];
  [specLilBox display];
return self;
}

/* - - - - - - - - - - - - -   R U L E   P A N E L   - - - - - - - - - - - - */

- windowDidBecomeKey:sender {
	nowBox=NULL;
	[menuCopy setTarget: self];
  if (sender==mainWindow) nowBox=toRuleBox;
  if (sender==speshPanel) nowBox=nowSpesh;
  if (sender==infoPanel)  nowBox=sender;
	[menuCopy setAction: @selector(copyBox:)];
	[menuCopy setEnabled: YES];
	[menuPrint setTarget: sender];
	[menuPrint setAction: @selector(smartPrintPSCode:)];
	[menuPrint setEnabled: YES];
return self;
}

- windowDidResignKey:sender {
 	[menuCopy setEnabled: NO];
 	[menuPrint setEnabled: NO];
return self;
}

- copyBox:sender {
NXRect zbounds;
id     pBoard;
  pBoard = [Pasteboard new];
  [pBoard declareTypes: &NXPostScriptPboardType num: 1 owner: self];
  [[nowBox contentView] getBounds: &zbounds];
  [[nowBox contentView] writePSCodeInside: &zbounds to: pBoard]; 
return self;
}

- setDimension:sender {dn = [sender selectedRow]+1; return self;}

- protectGenRule:sender
{int i, j, k, i0, i1, i2,i3;
  i=j=[sender selectedCol];
  i3=i%KK; i/=KK;
  i2=i%KK; i/=KK;
  i1=i%KK; i/=KK;
  i0=i%KK; i/=KK;
  k=auxrule[i0][i1][i2][i3];
  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setEnabled: k];
  for (i=0; i<KK; i++) [[ascru cellAt: i: j] setBordered: k];
  auxrule[i0][i1][i2][i3]=!k;
return self;
}

- relatedRule:sender {
char    ii[RSYM][KK][KK][KK][KK], wnum[RSYM][WNML], c[WNML], *titl;
int	j, k, l, jj[KK];
  l=allperm(wnum,ii,ascrule);
  titl=[[sender selectedCell] title];
       if (strcmp(titl,"cycle  5")==0)  k=1;
  else if (strcmp(titl,"cycle  4")==0)  k=5; 
  else if (strcmp(titl,"cycle  3")==0)  k=20; 
  else if (strcmp(titl,"cycle  2")==0)  k=60; 
  else if (strcmp(titl,"reflected")==0) k=120;
  else if (strcmp(titl,"cluster")==0)   k=RSYM;
  else if (strcmp(titl,"flip")==0)      k=60;
  else if (strcmp(titl,"least")==0)     k=l;
 /* es "ele" no "uno" */
  else  				k=0;
  if (k==RSYM) {
    clumin(c);
    longwolftoasc(c);
    [self setAllRules: self];
    return self;
    }
  chrucopy(ascrule,ii[k],'w');
  [self setAllRules: self];
  if ([changeLine state]) {
    l=vecperm(jj,k);
    for (j=0; j<AL; j++) arr1[j]=jj[arr1[j]];
    if (l) {
      for (j=0; j<AL; j++) arr2[j]=arr1[AL-1-j];
      for (j=0; j<AL; j++) arr1[j]=arr2[j];
      }
    }
// printf ("related rules\n");
// for (k=0; k<RSYM; k++) printf("%s\n",wnum[k]);
return self;
}

/*  generate a table of permutations of a given rule         */
/*  and report the index of the rule with smallest wru       */
/*  wn - array to be filled with WNML-letter wolfram numbers */
/*  ii - array to be filled with ascrule symmetry images     */
/*  ru - reference KK8KK8KK table - e.g. ascrule	     */
/*  return value is the index of the least of all these	     */
/*  that is, wn[...] is the number, ii[...] is the rule      */
int allperm(wnum,ii,ru) 
  char wnum[][WNML], ii[][KK][KK][KK][KK], ru[KK][KK][KK][KK]; 
{int k, l,j,i,n;
   chrucopy(ii[0], ru, 'w');		 /* (0 1 2 3 4) identity */
 /* cyclic permutation n (0 1 2 3 4) */
   for (i=1; i<5; i++) chrucopy(ii[i],ii[i-1], 'y');
 /* cyclic permutation n-1 (1 2 3 4)*/
   for (i=5; i<20; i++) chrucopy(ii[i], ii[i-KK], 'x');
 /* cyclic permutation n-2 (2 3 4)*/
   for (i=20; i<60; i++) chrucopy(ii[i], ii[i-20], 'v');
/* cyclic permutation n-3 (transpose) (3 4) (2 3).. */
   for (i=60; i<120; i++) chrucopy(ii[i],ii[i-60], 't');
/* Reflexion */
for (i=RSYM/2; i<RSYM; i++) chrucopy(ii[i],ii[i-RSYM/2],'r'); 

    for (k=0, l=0; k<240; k++) {
     wrru(wnum[k],ii[k]); 
   /* printf("%s   ---->%s\n",wnum[k],wnum[l]); */
    if (strcmp(wnum[k],wnum[l]) < 0) l=k;
    }
return l;
//printf("%d\n",l);
}

/* fill a KK-vector ii with inverse permutation #n of its indices  */
/* inverse is because this will be used to generate configurations */
/* return TRUE if there was a reflection of the neighborhood       */
int vecperm(ii,n) int ii[KK], n; {int i, k, l;
  l=!(n<6); k=(l?n-6:n);
  switch (k) {
    case 0: for (i=0; i<KK; i++) ii[i]=i; break;
    case 1: for (i=0; i<KK; i++) ii[i]=ycc(i); break;
    case 2: for (i=0; i<KK; i++) ii[i]=cyy(i); break;
    case 3: for (i=0; i<KK; i++) ii[i]=fli(i); break;
    case 4: for (i=0; i<KK; i++) ii[i]=fli(ycc(i)); break;
    case 5: for (i=0; i<KK; i++) ii[i]=fli(cyy(i)); break;
    default: for (i=0; i<KK; i++) ii[i]=i; break;}
  return l;
}

/* copy a related (character) rule */
/* c = w - no change               */
/* c = y - cyclic permutation      */
/* c = r - reflected               */
/* c = t - transpose            */

void chrucopy(ii,jj,c) char ii[KK][KK][KK][KK], jj[KK][KK][KK][KK], c; {
int i0, i1, i2, i3;
  switch (c) {
    case 'w':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      for (i2=0; i2<KK; i2++) 
      for (i3=0; i3<KK; i3++) 
     	ii[i0][i1][i2][i3]=jj[i0][i1][i2][i3];
      break;
    case 'y':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      for (i2=0; i2<KK; i2++) 
      for (i3=0; i3<KK; i3++) 
     	ii[i0][i1][i2][i3]=ycc(jj[cyy(i0)][cyy(i1)][cyy(i2)][cyy(i2)]);
      break;
    case 'x':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      for (i2=0; i2<KK; i2++) 
      for (i3=0; i3<KK; i3++) 
     	ii[i0][i1][i2][i3]=xcc(jj[cxx(i0)][cxx(i1)][cxx(i2)][cxx(i3)]);
      break;
    case 'v':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      for (i2=0; i2<KK; i2++) 
      for (i3=0; i3<KK; i3++) 
     	ii[i0][i1][i2][i3]=vcc(jj[cvv(i0)][cvv(i1)][cvv(i2)][cvv(i3)]);
      break;
    case 'r':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      for (i2=0; i2<KK; i2++) 
      for (i3=0; i3<KK; i3++) 
     	ii[i0][i1][i2][i3]=jj[i3][i2][i1][i0];
      break;
    case 't':
      for (i0=0; i0<KK; i0++) 
      for (i1=0; i1<KK; i1++) 
      for (i2=0; i2<KK; i2++) 
      for (i3=0; i3<KK; i3++) 
      	ii[i0][i1][i2][i3]=fli(jj[fli(i0)][fli(i1)][fli(i2)][fli(i3)]);
      break;
    default: break;}
}

int fli(i) int i; {switch (i) {
	case '0': return '0';
        case '1': return '1';
        case '2': return '2';
	case '3': return '4'; 
	case '4': return '3';
        case  0 : return  0 ;
        case  1 : return  1 ;
        case  2 : return  2 ;
	case  3 : return  4 ; 
	case  4 : return  3 ;
	default:  return '0';}
}

int cyy(i) int i; {switch (i) {
	case '0': return '1';
	case '1': return '2'; 
	case '2': return '3';
        case '3': return '4';
        case '4': return '0';
	case 0: return 1;
	case 1: return 2; 
	case 2: return 3;
        case 3: return 4; 
	case 4: return 0;
	default:  return '0';}
}

int ycc(i) int i; {switch (i) {
	case '0': return '4';
	case '1': return '0'; 
	case '2': return '1';
        case '3': return '2';
        case '4': return '3';
	case 0: return 4;
	case 1: return 0; 
	case 2: return 1;
        case 3: return 2; 
	case 4: return 3;
	default:  return '0';}
}

int cxx(i) int i; {switch (i) {
	case '0': return '0';
	case '1': return '2'; 
	case '2': return '3';
        case '3': return '4';
        case '4': return '1';
	case 0: return 0;
	case 1: return 2; 
	case 2: return 3;
        case 3: return 4; 
	case 4: return 1;
	default:  return '0';}
}

int xcc(i) int i; {switch (i) {
	case '0': return '0';
	case '1': return '4'; 
	case '2': return '1';
        case '3': return '2';
        case '4': return '3';
	case 0: return 0;
	case 1: return 4; 
	case 2: return 1;
        case 3: return 2; 
	case 4: return 3;
	default:  return '0';}
}

int cvv(i) int i; {switch (i) {
	case '0': return '0';
	case '1': return '1'; 
	case '2': return '3';
        case '3': return '4';
        case '4': return '2';
	case 0: return 0;
	case 1: return 1; 
	case 2: return 3;
        case 3: return 4; 
	case 4: return 2;
	default:  return '0';}
}

int vcc(i) int i; {switch (i) {
	case '0': return '0';
	case '1': return '1'; 
	case '2': return '4';
        case '3': return '2';
        case '4': return '3';
	case 0: return 0;
	case 1: return 1; 
	case 2: return 4;
        case 3: return 2; 
	case 4: return 3;
	default:  return '0';}
}


void clumin(c) char *c; {
char d[WNML], ii[RSYM][KK][KK][KK][KK], wnum[RSYM][WNML];
int i, j, l;
  wrru(c,ascrule);
  l=allperm(wnum,ii,ascrule);
  for (j=0; j<RSYM; j++) {
    for (i=0; i<RSYM/2; i++) {
      chrucopy(ascrule,ii[j],'w');
      asctobin();
      ptedbrul(&binrule,&binrule,i);
      bintoasc();
      wrru(d,ascrule);
      if (strcmp(d,c)<0) strcpy(c,d);
      }
    }
}

/* create the rule defined by the "symmetric rule" panel */
- symRule:sender {
int j00, j01, j02, j10, j11, j12, j20, j21, j22;
int i0, i1, i2, i3, j0, j1, r;
j00=[[s00 selectedCell] tag];
j01=[[s01 selectedCell] tag];
j02=[[s02 selectedCell] tag];
j10=[[s10 selectedCell] tag];
j11=[[s11 selectedCell] tag];
j12=[[s12 selectedCell] tag];
j20=[[s20 selectedCell] tag];
j21=[[s21 selectedCell] tag];
j22=[[s22 selectedCell] tag];
  for (i0=0; i0<KK; i0++) 
     for (i1=0; i1<KK; i1++) 
        for (i2=0; i2<KK; i2++) 
           for (i3=0; i3<KK; i3++){
             j0=KK+i1-i0;
             j1=KK+i2-i1;
             r =j00+j0*(j10+j0*j20)+j1*(j01+j1*j20);
             r+=j0*j1*(j11+j0*j21+j1*j12);
             r+=j0*j0*j1*j1*j22;
            switch([[sIncr selectedCell] tag]) {
             case 0: r+=i0; break;
             case 1: r+=i1; break;
             case 2: r+=i2; break;
	     case 3: r+=i3; break;
             case 4: r+=(KK-i0)+(KK-i1); break;
             case 5: r+=(KK-i1)+(KK-i2); break;
             case 6: r+=(KK-i2)+(KK-i3); break;
	     case 7: r+=(KK-i3)+(KK-i0); break;
             case 8: break;
             default: break;}
    ascrule[i3][i2][i1][i0]=r%KK+'0';
    }
  [self setAllRules: self];
  return self;
  }

- readWRule:sender {char *c;
   c=[sender stringValue];
   if (longwolftoasc(c)) [self setAllRules: self];
   else
     [ruleNumber setStringValue:"Invalid"]; 
 return self;
}

int longwolftoasc(char *c) {
char d[WNML], e;
int i, l, n, i0, i1, i2, i3;
  l=strlen(c);
  for (i=0; i<WNML; i++) d[i]=0;
  for (i=0; i<l; i++) {
    e=c[i];
         if ('0' <= e  &&  e <= '9') n=e-'0';
    else if ('a' <= e  &&  e <= 'o') n=e-'a'+10;
    else if ('A' <= e  &&  e <= 'O') n=e-'A'+10;
    else    return FALSE;
    d[WNML-1-l+i]=n;
    }
  for (i=0, i0=0, i1=0, i2=0, i3=0; i<WNML-1; i++) {
    n=d[WNML-2-i];
    ascrule[i0][i1][i2][i3]='0'+n%KK;
    i1++; if (i3>=KK) {i3=0; i2++;} 
	  if (i2>=KK) {i2=0; i1++;}
	  if (i1>=KK) {i1=0; i0++;}
	  if (i0>=KK) return TRUE;
    ascrule[i0][i1][i2][i3]='0'+n%KK;
    i1++; if (i3>=KK) {i3=0; i2++;} 
	  if (i2>=KK) {i2=0; i1++;}
	  if (i1>=KK) {i1=0; i0++;}
	  if (i0>=KK) return TRUE;
    }
  return TRUE;
} 

/* for 5-state automata, group the neighborhoods by twos and  */
/* use ASCII letters base 25 - that is, 0-9, A-O.	      */
void wru(c) char *c; {wrru(c,ascrule);}

/* calculate wru from an argument rule */
void wrru(c, ru) char *c, ru[KK][KK][KK][KK]; {int  i, j, k, l, m, n;
k=0; j=0; l=0; m=0; n=0;
while (TRUE) {
  i=(ru[j][k][l][m]-'0')+'0'; 
  m++;
  if (m>=KK) {m=0; l++;}
  if (l>=KK) {l=0; k++;}
  if (k>=KK) {k=0; j++;}
  if (j>=KK) break;
  i+=KK*(ru[j][k][l][m]-'0');
  if (m>=KK) {m=0; l++;}
  if (l>=KK) {l=0; k++;}
  if (k>=KK) {k=0; j++;}
  if (j>=KK) break;
  if (i>'9') i=i+('A'-':');
  c[WNML-1-n-1]=i;
  n++;
  }
c[0]=i;
c[WNML-1]=0; 
}

- setRule:sender 
{char ch[WNML]; int i, ii, j, jj, i0, i1, i2,i3;
//   wrru(ch,ascrule);
//   [ruleNumber setStringValue: ch];
   ii= [sender selectedRow];
   jj=j= [sender selectedCol];
  i3=j%KK; j/=KK;  
  i2=j%KK; j/=KK;
  i1=j%KK; j/=KK;
  i0=j%KK; j/=KK;
  ascrule[i0][i1][i2][i3]='0'+ii;
  for (i=0; i<KK; i++) [[ascru cellAt: i: jj] setIntValue: NO];
  [[ascru cellAt: ii: jj] setIntValue: YES];
  [self setAllRules: self];
  return self;
}

- setAllRules:sender 
{char ch[WNML], c[2]; int i, j, jj, i0, i1, i2, i3;
//   wrru(ch,ascrule);
//   [ruleNumber setStringValue: ch];
   asctobin();
//  for (i0=0; i0<KK; i0++) 
//     for (i1=0; i1<KK; i1++) 
//        for (i2=0; i2<KK; i2++)
//           for (i3=0; i3<KK; i3++) {
//         i=KK*(KK*i0+i1)+i2;                                                                                                                                                                                                               
//         j=KK*(KK*i1+i2)+i3;
//	 c[0]=ascrule[i0][i1][i2][i3]; c[1]=0;                                                                                                                                                                                                             
//         [[ascru cellAt: i: j] setTitle: c];
//         if (auxrule[i0][i1][i2][i3]) [[ascru cellAt: i: j] setEnabled: NO];
//         if (auxrule[i0][i1][i2][i3]) [[ascru cellAt: i: j] setBordered: NO];
//    }
//   wrru(ch,ascrule);
//   [ruleNumber setStringValue: ch];
//   [self nxasfreq];
   [self showProbability: pSliders];
   if      (istot()) {asctotot(); [self setTotRules: self];}
//    else if (isstot()) [totlRef setStringValue: "semitotalistic"];
      else {
	[toascru setEmptySelectionEnabled: YES];
	[toascru selectCellAt: -1: 0];
	[totlRef setStringValue: " "];
	[toRuleNumber setStringValue: " "];
	}

return self;
}

- freeAllRules:sender {int i, j; 
    for (i=0; i<KK; i++) for (j=0; j<DS; j++) 
      [[[ascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    auxzero();
return self;
}

- zeroRules:sender {
  asczero();
  auxzero();
  [self setAllRules: self];
return self;
}

- ranRules:sender {
  granrule();
  [self setAllRules: self];
return self;
}

- ranPRules:sender {
  granprule();
  [self setAllRules: self];
return self;
}

/* generate a random rule */
void granrule() {int i, i0, i1, i2,i3;
for (i0=0; i0<KK; i0++)
   for (i1=0; i1<KK; i1++)
      for (i2=0; i2<KK; i2++) 
         for (i3=0; i3<KK; i3++){
            i=(random()&0xFF)%KK;
	    ascrule[i0][i1][i2][i3]=i+'0';
	    //  printf("%d",i);
  }
//  printf("\n");
}

/* generate a random protected rule */
void granprule() {int i0, i1, i2,i3, i, j;
i=0; j=0;
for (i0=0; i0<KK; i0++)
   for (i1=0; i1<KK; i1++)
      for (i2=0; i2<KK; i2++) 
	 for (i3=0; i3<KK; i3++){
            if (i%8 == 0) j=random();  i++;
  	    if (auxrule[i0][i1][i2][i3]==0) ascrule[i0][i1][i2][i3]='0'+j%KK;
  j/=KK;
  }
}

- showProbability:sender {int i; double pp, p[KK];
  for (i=0; i<KK; i++) p[i]=[[sender cellAt: i: 0] doubleValue];
  for (pp=0.0, i=0; i<KK; i++) pp+=p[i];
  for (i=0; i<KK; i++) {
    [[pSliders cellAt: i: 0] setDoubleValue: p[i]/pp];
    [[pWindows cellAt: i: 0] setDoubleValue: p[i]/pp];
    }
return self;
}

- randomLine:sender {double p[KK]; int i;
  for (i=0; i<KK; i++) p[i]=[[pSliders cellAt:i:0] doubleValue];
  ranblin(p[0],p[1],p[2],p[3],p[4]);
return self;
}

- sCellLine:sender {
  zerline();
  switch (dn) {
    case 1: putionj(1,0); break;
    case 2: ranplacor(); break;
    case 3: ransolcor(); break;
    case 5: ranplacor(); break;
    case 6: ransolcor(); break;
    default: putionj(1,0); break;}
return self;
}

- uniformLine:sender {ranblin(0.2,0.2,0.2,0.2,0.2); return self;}

- useRECLine:sender {
  [RECPanel makeKeyAndOrderFront: sender];
  [RECValue setStringValue: "*"];
return self;
}

- runRECLine:sender {
printf("hello from runRec\n");
  [RECValue setStringValue: " "];
  if (rec([sender stringValue])) 
	[RECValue setStringValue: "T"]; else [RECValue setStringValue: "F"];
return self;
}

/* - - - - - - - - -   D E M O N S T R A T I O N   R U L E   - - - - - - - - */

- setDemo:sender {char ch[WNML];
   wrru(ch,ascrule);
   [ruleNumber setStringValue: ch];
  xtoasc([[sender selectedCell] tag]);
  [self setAllRules: self];
  return self;
}

/* - - - - - - - - - - -    P E R M U T E D   R U L E    - - - - - - - - - - */

- pmutRule: sender {
//   asctobin();
//   ptedbrul(&binrule,&binrule,[pRu intValue]);
//   [self setAllRules:self];
return self;
}

void ptedbrul(pr,br,k) birular *pr, *br; int k; {int i;
  for (i=0; i<KK*KK; i++) pr->one[i]=permu[k][br->one[i]];
}

/* - - - - - - - - - - - - -   G F ( 5 )   R U L E   - - - - - - - - - - - - */

- setMCoeff:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    gf5rule[t]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- setVCoeff:sender {int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    gf5rule[t+9]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- setSCoeff:sender {int s;
    s=[sender selectedRow];
    gf5rule[12]=s+'0';
    [gfWindow setDocEdited:YES];
return self;
}

- enterGF5Rule:sender {
//   int i; for (i=0; i<13; i++) printf("%1d ",gf5rule[i]); printf("\n");
//    gftoasc();
//    [self setAllRules:self];
//    [gfWindow setDocEdited:NO];
return self;
}

/* - - - - - - - -    S E M I T O T A L I S T I C   R U L E    - - - - - - - */
 
- setSemiState:sender {
  int s, t,i;
    s=[sender selectedRow];
    t=[sender tag];
    if ([sender tag]==0) {
      for (i=0; i<KK; i++)
	{
           [[sem0 cellAt: i: [sender selectedCol]] setIntValue: NO];
           }
	 [[sem0 cellAt: s: [sender selectedCol]] setIntValue: YES];
    }
    if ([sender tag]==1) {
      for (i=0; i<KK; i++)
	{
           [[sem1 cellAt: i: [sender selectedCol]] setIntValue: NO];
           }
           [[sem1 cellAt: s: [sender selectedCol]] setIntValue: YES];
       } 
    if ([sender tag]==2) {
      for (i=0; i<KK; i++)
	{
           [[sem2 cellAt: i: [sender selectedCol]] setIntValue: NO];
           }
	   [[sem2 cellAt: s: [sender selectedCol]] setIntValue: YES];

    }


    strule[t][[sender selectedCol]]=s+'0';
    [toWindow setDocEdited:YES];
    //sttoasc(); 
  return self;
  }

- enterSemiRule:sender {
    sttoasc();
    [self setAllRules:self];
    [toRuleNumber setIntValue: totonu(0)];
    [stWindow setDocEdited:NO];
return self;
}

/* - - - - - - - - - -    T O T A L I S T I C   R U L E    - - - - - - - - - */

- setTotalisticState:sender {
  int s, t;
    s=[sender selectedRow];
    t=[sender tag];
    ttrule[t]=s+'0';
    [toWindow setDocEdited:YES];
  return self;
  }
 
- enterTotalisticRule:sender {
    totoasc();
    [self setAllRules:self];
    [toRuleNumber setIntValue: totonu(0)];
    [toWindow setDocEdited:NO];
return self;
}

int longtwolftoasc(char *c) {  
char d[TS], e;
int i, l, n, nn, k;
  l=strlen(c);
  nn=(((TS)%2==0)?(TS)/2:(TS)/2+1);
  for (i=0; i<nn; i++) d[i]=0;
  for (i=0; i<l; i++) {
       e=c[i];
         if ('0' <= e  &&  e <= '9') n=e-'0';
    else if ('a' <= e  &&  e <= 'o') n=e-'a'+10;
    else if ('A' <= e  &&  e <= 'O') n=e-'A'+10;
        else return FALSE;
    d[nn-l+i] = n; 
    }
  k=0;
  for (i=0; i<nn; i++) {
    n=d[nn-1-i];
    ttrule[k] = '0' + n%KK; n/=KK; k++;
    if (k==TS) break;
    ttrule[k] = '0' + n%KK; k++;
    if (k==TS) break;
    }
return TRUE;
} 

/* calculate base 25 totalistic rule number */
void wtrru(c, ru) char *c, ru[TS]; {
int  i, j, k, m;
j=0; m=0; k=((TS)%2==0)?(TS)/2+1:(TS)/2+2;
while (TRUE) {
  i=(ru[j]-'0')+'0'; 
  j++; if (j>=TS) break;
  i+=KK*(ru[j]-'0');
  if (i>'9') i=i+('A'-':');
  if (i>'Z') i=i+('a'-'[');
    c[k-1-m-1]=i;
  j++; if (j>=TS) break;
  m++;
  }
c[0]=i;
c[k-1]=0; 
}

- readTRule:sender {
  if (longtwolftoasc([sender stringValue])) {
	totoasc();
	[self setAllRules: self];
	} else [sender setStringValue: "invalid"];
return self;
}

- setTotRule:sender  {char ch[WNML]; int i, ii, jj;
  wrru(ch,ascrule);
  [ruleNumber setStringValue: ch];
  ii= [sender selectedRow];
  jj= [sender selectedCol];
  ttrule[jj]='0'+ii;
  for (i=0; i<KK; i++) [[toascru cellAt: i: jj] setIntValue: NO];
  [[toascru cellAt: ii: jj] setIntValue: YES];
  [self setTotRules: self];
  return self;
}

- setTotRules:sender {char ch[WNML]; int i, j;
//   wrru(ch,ascrule);
//   [ruleNumber setStringValue: ch];
  totoasc();
  asctobin();
  for (j=0; j<TS; j++) {
    for (i=0; i<KK; i++) {
      [[toascru cellAt: i: j] setIntValue: NO];
      if (tarule[j]) [[toascru cellAt: i: j] setEnabled: NO];
      if (tarule[j]) [[toascru cellAt: i: j] setBordered: NO];
      }
    [[toascru cellAt: ttrule[j]-'0': j] setIntValue: YES];
    }
//  wrru(ch,ascrule);
    [ruleNumber setStringValue: ch];
//  [self nxasfreq];
   if      (istot()==1) {
	[totlRef setStringValue: "totalistic"];
	wtrru(ch,ttrule);
	[toRuleNumber setStringValue: ch];
	}
//    else if (isstot()==1) [totlRef setStringValue: "semitotalistic"];
      else {
	[toascru setEmptySelectionEnabled: YES];
	[toascru selectCellAt: -1: 0];
	[totlRef setStringValue: " "];
	[toRuleNumber setStringValue: " "];
	}
return self;
}

- freeAllTotRules:sender {int i, j; 
    for (i=0; i<KK; i++) for (j=0; j<TS; j++) 
      [[[toascru cellAt: i: j] setEnabled:  YES] setBordered: YES];
    auxzero();
return self;
}

- zeroTotRules:sender {
  asczero();
  auxzero();
  [self setAllRules: self];
return self;
}

- ranTRule:sender {int i;
  for (i=0; i<TS; i++) ttrule[i]=(random()&0xFF)%KK+'0';
  totoasc();
  asctobin();
  [self setAllRules: self];
return self;
}

- ranPTotRules:sender {
  granprule();
  asctobin();
  [self setAllRules: self];
return self;
}

/* generate a random rule */
void grantotrule() {int i, i0, i1, i2,i3;
for (i0=0; i0<KK; i0++)
   for (i1=0; i1<KK; i1++)
      for (i2=0; i2<KK; i2++) 
         for (i3=0; i3<KK; i3++){
            i=(random()&0xFF)%KK;
	    ascrule[i0][i1][i2][i3]=i+'0';
  }
}

/* generate a random protected rule */
void granptotrule() {int i0, i1, i2,i3, i, j;
i=0; j=0;
for (i0=0; i0<KK; i0++)
   for (i1=0; i1<KK; i1++)
      for (i2=0; i2<KK; i2++) 
	 for (i3=0; i3<KK; i3++){
            if (i%8 == 0) j=random();  i++;
  	    if (auxrule[i0][i1][i2][i3]==0) ascrule[i0][i1][i2][i3]='0'+j%KK;
  j/=KK;
  }
}

/* - - - - - - - -    M I S C E L L A N E O U S   R U L E S    - - - - - - - */

- enterMiscRule:sender {
char c[WNML];
int  i, j, k, l;
int  i0, i1, i2, i3;
int  s[KK];
  switch ([sender selectedRow]) {
    case 0: 					/* matching pair */
	for (i0=0; i0<KK; i0++)
	for (i1=0; i1<KK; i1++)
	for (i2=0; i2<KK; i2++)
	for (i3=0; i3<KK; i3++) {
	  for (j=0; j<KK; j++) s[j]=0;
	  s[i0]++; s[i1]++; s[i2]++; s[i3]++;
	  for (j=0, k=KK; j<KK; j++)
	         if (s[j]==4 || s[j]==3) {i=j; break;}
	    else if (s[j]==2 && k==KK) i=j;
	    else if (s[j]==2) {k=j; break;}
	  if (k!=KK) i=KK-i-k;
	  ascrule[i0][i1][i2][i3]=i+'0';
	  }
	break;
    case 1: 					/* edible pair	 */
	for (i0=0; i0<KK; i0++)
	for (i1=0; i1<KK; i1++)
	for (i2=0; i2<KK; i2++)
	for (i3=0; i3<KK; i3++) {
	       if (i0==i1) {i=i0; j=i2; k=i3;}
	  else if (i0==i2) {i=i0; j=i1; k=i3;}
	  else if (i0==i3) {i=i0; j=i1; k=i2;}
	  else if (i1==i2) {i=i1; j=i0; k=i3;}
	  else if (i1==i3) {i=i1; j=i0; k=i2;}
	  else    	   {i=i2; j=10; k=i1;}
	  l=(i+1)%KK;
	  if (l==j || l==k) i=l;
	  ascrule[i0][i1][i2][i3]=i+'0';
	  }
	break;
    case 2: 					/* majority      */
	for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++)
	for (i2=0; i2<KK; i2++) for (i3=0; i3<KK; i3++) {
	  for (i=0; i<KK; i++) s[i]=0;
	  s[i0]++; s[i1]++; s[i2]++; s[i3]++;
	  for (i=j=k=0; i<KK; i++) if (s[i]>j) {j=s[i]; k=i;}
	  if (j>RR/2) ascrule[i0][i1][i2][i3]=k+'0';
	  }
	break;
    default: break;}
//   wrru(c,ascrule);
//   [ruleNumber setStringValue: c];
   asctobin();
return self;
}

/* - - - - - - - - - -    X E N O P H I L I C   R U L E    - - - - - - - - - */

- xenophilic:sender {
//  oxtoasc(xr);
  ranvachrul(xp);
  [self setAllRules: self];
return self;
}

- xenophobic:sender {
//  oxtoasc(xr);
  ranvachrul(xq);
  [self setAllRules: self];
return self;
}

int ran2of3(a,b) int a, b; {
if ((random()%1001)<500) return a; else return b;
}

int ran3of3(a,b,c) int a, b, c; {
if ((random()%1001)<333) return a;
if ((random()%1001)<667) return b;
return c;
}

/* generate a random variable choice rule switch (c[KK*(KK*i0+i1)+i2]-'0') {*/
void ranvachrul(c) char *c; {int i0, i1, i2, i3, i, j;
i=j=0;
for (i0=0; i0<KK; i0++)
   for (i1=0; i1<KK; i1++)
     for (i2=0; i2<KK; i2++) 
        for (i3=0; i3<KK; i3++){
           switch (c[j]-'0') {
            	case 0: break;
    		case 1: i=0; break;
    		case 2: i=1; break;
    		case 3: i=ran2of3(0,1); break;
    	        default: i=0; break;}
	  j++; 	
    	  ascrule[i0][i1][i2][i3]='0'+i;
  }
}

/* - - - - - - - - - - -   D E S I G N E D   R U L E   - - - - - - - - - - - */

- deZign:sender {int k, n, i0, i1, i2;
    k=[sender intValue];
    if (k>=0 && k <=KK) return self;
    k=[sender tag];
    i2=k%KK; k/=KK;
    i1=k%KK; k/=KK;
    i0=k%KK;
    switch ([designRef selectedRow]) {
      case 0: k=i0; break;
      case 1: k=i1; break;
      case 2: k=i2; break;
      default: k=0; break;}
    n=[designPrm selectedRow];
    k=permut(k,n);
    [sender setIntValue: k];
return self;
}

- clearDesign:sender {
id  z;
int i;
  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) [z setIntValue: KK];
return self;
}

- copyToDesign:sender {
id  z;
int i0, i1, i2, i3;
  z=zeZeZe;
  for (i0=0; i0<KK; i0++) 
     for (i1=0; i1<KK; i1++) 
        for (i2=0; i2<KK; i2++) 
           for (i3=0; i3<KK; i3++){
    [z setIntValue: ascrule[i0][i1][i2][i3]-'0'];
    z=[z nextText];
    }    
return self;
}

- enterDesign:sender {
int i, k, i0, i1, i2, i3;
id  z;
  for (i=0, z=zeZeZe; i<DS; i++, z=[z nextText]) {
    k=i;
    i3=k%KK; k/=KK;
    i2=k%KK; k/=KK;
    i1=k%KK; k/=KK;
    i0=k%KK;
    k=[z intValue];
    ascrule[i0][i1][i2][i3]=(k<KK?k:0)+'0';
    auxrule[i0][i1][i2][i3]=(k<KK?1:0);
    }
  [self setAllRules: self];
return self;
}

/* - - - - - - - - - - - -  T R I V I A   P A N E L  - - - - - - - - - - - - */

/* graph the frequencies of ascrule 		 */
/* put dot at coordinates (u,v)			 */
/* percentages evolving into each value		 */
/* percentages shifting - adds to more than 100% */
/* entropy and Langton's lambda = % nonquiescent */

- nxasfreq {
int    i, j, k, i0, i1, i2,i3,i4; 
int    stat[KK], statp[KK][KK];	/* statistic counts */
int 	shift[RR];
int    xe;
double staf[KK],stapf[KK][KK], t, pp,qq;

xe=0;
pp=1.0/((double)(DS));
qq=pp/((double)KK);
for (i=0; i<RR; i++) shift[i]=0;
for (i=0; i<KK; i++) { stat[i]=0; for (j=0; j<KK; j++) statp[i][j]=0;}
for (i0=0; i0<KK; i0++)
   for (i1=0; i1<KK; i1++)
      for (i2=0; i2<KK; i2++) 
         for (i3=0; i3<KK; i3++){
            j=ascrule[i0][i1][i2][i3]-'0';
            stat[j]++;
  	    if (j==i0) shift[0]++    ;
  	    if (j==i1) shift[1]++;
  	    if (j==i2) shift[2]++;
	    if (j==i3) shift[3]++;
	    if (j==i0 || j==i1 || j==i2 || j==i3) xe++;
	    for (i4=0; i4<KK; i4++){
  	      k=ascrule[i1][i2][i3][i4]-'0';
              statp[j][k]++;
  	     }
	  }
for (i=0; i<KK; i++) staf[i]=((double)stat[i])*pp;
for (i=0; i<KK; i++) [[statState cellAt: 0: i] setDoubleValue: staf[i]];
for (i=0; i<RR; i++)
	[[statIndx cellAt:i :0] setDoubleValue: ((double)shift[i])*pp];
for (i=0, t=0.0; i<KK; i++) t+=staf[i]*log(staf[i]);
	[statLamb setDoubleValue: 1.0-staf[0]];
	[statEntro setDoubleValue: -t/log((double)KK)];
for (i=0, t=0.0; i<KK; i++) 
  for (j=0; j<KK; j++) {
    stapf[i][j]=((double)statp[i][j])*qq;
    [[statPairs cellAt: i: j] setDoubleValue: stapf[i][j]];
    t+=stapf[i][j]*log(stapf[i][j]);
  }
[statPentro  setDoubleValue: -t/log((double)(KK*KK))];
[statXeno  setDoubleValue: ((double)(DS-xe))*pp at: 0];
[statXeno  setDoubleValue: ((double)xe)*pp at: 1];
return self;
}

/*****   Ok 			15-08-95 	      *******/

/*     - - - - - - - - -  ARITHMETIC COMBINATION  - - - -  - - - */

 - arithmCombs:sender {
int i0,i1,i2,i3;
birular aza, bzb, czc;
   [self readWRule: [twoRules cellAt: 0: 0]];
   asctobin();
   bincopy(&aza,binrule);
   binprint(aza);
   [self readWRule: [twoRules cellAt: 1: 0]];
   asctobin();
   bincopy(&bzb,binrule);
   binprint(bzb);
   switch ([sender selectedRow]) {
      case 0: binsum(&czc,aza,bzb); break;
      case 1: binprod(&czc,aza,bzb); break;
      default: printf("arithCombs\n"); 
   break;}
   binprint(czc);
   for (i0=0; i0<KK ;i0++) 
      for (i1=0; i1<KK ;i1++) 
	 for (i2=0; i2<KK ;i2++) 
	    for (i3=0; i3<KK; i3++)
               binrule[i0][i1][i2][i3]=czc.four[i0][i1][i2][i3]; 
   bintoasc();
   [self setAllRules: self];
return self;
}

- initTwoRules:sender {
char ch[WNML];
   granrule();
//   wrru(ch,ascrule);
//   [[twoRules cellAt: [sender selectedRow]: 0] setStringValue: ch];
return self;
}

/* copy one binary rule from another */
void bincopy(rz,rx) birular *rz; int rx[KK][KK][KK][KK];
{int i0, i1, i2, i3;
   for (i0=0; i0<KK; i0++)
      for (i1=0; i1<KK; i1++)
         for (i2=0; i2<KK; i2++)
            for (i3=0; i3<KK; i3++)
               rz->four[i0][i1][i2][i3]=rx[i0][i1][i2][i3]+'0';
}


/*fill ascrule from binrule*/
void bintoasc()
{int i0, i1, i2, i3;
   for (i0=0; i0<KK; i0++)
      for (i1=0; i1<KK; i1++)
         for (i2=0; i2<KK; i2++)
            for (i3=0; i3<KK; i3++)
               ascrule[i0][i1][i2][i3]=binrule[i0][i1][i2][i3]+'0';
}

/*sum two binary rules mod KK*/
void binsum(rz,rx,ry) birular *rz, rx, ry;
{int i; for (i=0; i<K4; i++) rz->one[i]=rx.one[i]+ry.one[i]%KK;}


/*multiply two binary rules mod KK*/
void binprod(rz,rx,ry) birular *rz, rx, ry;
{int i; for (i=0; i<K4; i++) rz->one[i]=rx.one[i]+ry.one[i]%KK;}


/*print a binary rules (all 16 numbers)*/
void binprint(rz) birular rz;
{int i;
      for (i=0; i<KK*KK*KK*KK; i++) printf("%c",rz.one[i]+'0');
      printf("\n");
}

/* ================   c o m p o s i t e   r u l e    ============= */

  - composRule:sender
  { long int ru1, ru2, ru3, br1[KK][KK], br2[KK][KK], br3[KK][KK];
    int  i0, i1, i2, i3;
     ru1=[[composRuleNumb cellAt: 0: 0] intValue];
     ru2=[[composRuleNumb cellAt: 1: 0] intValue];
     ru3=[[composRuleNumb cellAt: 2: 0] intValue];
     numtobin2h(br1, ru1);
     numtobin2h(br2, ru2);
     numtobin2h(br3, ru3);
     for(i0=0; i0<KK; i0++) 
      for(i1=0; i1<KK; i1++) 
       for(i2=0; i2<KK; i2++)
        for(i3=0; i3<KK; i3++)
          ascrule[i0][i1][i2][i3] = br3[br2[br1[i0][i1]][br1[i1][i2]]][br2[br1[i1][i2]][br1[i2][i3]]] + '0';
     [self setAllRules: self];
     return self;
    }

   - compxRule:sender
   {long int i;
      i= [[composRuleNumb cellAt: 0: 0] intValue];
      [[composRuleNumb cellAt: 0: 0] setIntValue :
                       [[composRuleNumb cellAt: 1: 0] intValue]];
      [[composRuleNumb cellAt: 1: 0] setIntValue :
                       [[composRuleNumb cellAt: 2: 0] intValue]];

     [[composRuleNumb cellAt: 2: 0] setIntValue: i];
     return self;
     }

   - comprRule:sender 
    {
       [[composRuleNumb cellAt: 0: 0] setIntValue: random()% 16];
       [[composRuleNumb cellAt: 1: 0] setIntValue: random()% 16];
       [[composRuleNumb cellAt: 2: 0] setIntValue: random()% 16];
      return self;

      }

   void numtobin2h(ru, n) long int ru[KK][KK], n;
  { int i, j, i0, i1;
    i=n;
      for(i0=0; i0<KK; i0++) for(i1=0; i1<KK; i1++) {
        j=i%KK; i/=KK;
        ru[i0][i1] = j;
        }
    }

@end

/* end RulePanel.m */
