
#import "LinePanel.h"
#import "nxlcau5t.h"
#import "rec.h"
//#import "rectbl.h"

char *iquon(int k); 
char *texth(int k); 
extern void wrru(char *c, char ar[KK][KK][KK][KK]);
void linix(int *xx, int i, int j, int nc);

extern char arule[DS], arr1[AL], arr2[AL], arr3[AL];
extern  int binrule[KK][KK][KK][KK];
extern char ascrule[KK][KK][KK][KK];
extern char auxrule[KK][KK][KK][KK];
extern char *r_pbufp;
extern int r_pbufl;
int auxi=0;

int lj=0;	/* row of editable cell		*/
int li=16;	/* column of editable cell	*/

int llal=0;

int longwolftoasc(char *c);


@implementation LinePanel


/* - - - - - - - - - - - - -   L I N E   P A N E L   - - - - - - - - - - - - */

/* try to match a given evolution */
- matEvol:sender 
{
char c, ch[20];
int  i, j, jj, k, m, s, sa, sb, t, nc;
int  xx[RR+1], pd[KK*KK*KK*KK+1][2];
				/* number of columns	*/
    if (auxi=0){
       for (i=0; i<AL; i++)  
	  ranlin();	
       [self showLine: self];
       [RulePanel setAllRules: self];
       wrru(ch,ascrule);
       [ruleNumber setStringValue: ch];
   }
   if (auxi=1){
       for (i=0; i<8; i++) for (j=0; j<40; j++) 
	   arr1[40*i+j]=[[lineButtons cellAt:i:j] tag];
       [self showLine: self];
       [RulePanel setAllRules: self];
       wrru(ch,ascrule);
       [ruleNumber setStringValue: ch];
   }
    m=1;
return self;
}

/* - - - - - - - - - - -   s c r e e n   e d i t i o n   - - - - - - - - - - */

- showLine:sender
{int i, j, k, ii, jj;
for (i=0; i<AL; i++) for (j=0; j<KK; j++) {
	  ii=i/40;
	  jj=i%40;
	  k=arr1[i];
 	  [[lineButtons cellAt:ii:jj] setIcon: iquon(k)];
	  [[lineButtons cellAt:ii:jj] setTitle: texth(k)];
	  [[lineButtons cellAt:ii:jj] setTag: k];
	  [[lineButtons cellAt:ii:jj] setIconPosition: NX_ICONONLY];
	  }
	  lj=0; li=16;
	  [[lineButtons cellAt:lj:li] setIconPosition: NX_TITLEONLY];
	  [lineRow selectCellAt:0:0];
 	  //auxi=0;
return self; }

- unitAll:sender
{int i, j;
for (i=0; i<40; i++) for (j=0; j<8;j++) {
  [[lineButtons cellAt:j:i] setTag: 1];
  [[lineButtons cellAt:j:i] setIcon: "1cell"];
  [[lineButtons cellAt:j:i] setTitle: "1"];
  [[lineButtons cellAt:j:i] setIconPosition: NX_ICONONLY];
  auxi=1;
  }
return self;
}

- zeroAll:sender
{int i, j;
for (i=0; i<40; i++) for (j=0; j<8;j++) {
  [[lineButtons cellAt:j:i] setTag: 0];
  [[lineButtons cellAt:j:i] setIcon: "0cell"];
  [[lineButtons cellAt:j:i] setTitle: "0"];
  [[lineButtons cellAt:j:i] setIconPosition: NX_ICONONLY];
  auxi=1;
  }
return self;
}

/* - - - - - - - - - - - -   c e l l   e d i t i o n   - - - - - - - - - - - */

- executeRule:sender 
{int i, i0, i1, i2, i3;
  if (lj==0) return self;
  i0=[[lineButtons cellAt:lj-1:(li+40-1)%40] tag];
  i1=[[lineButtons cellAt:lj-1:li] tag];
  i2=[[lineButtons cellAt:lj-1:(li+1)%40] tag];
  i3=[[lineButtons cellAt:lj-1:(li+2)%40] tag];
  i=binrule[i0][i1][i2][i3];
  [[lineButtons cellAt:lj:li] setTag: i];
  [[lineButtons cellAt:lj:li] setIcon: iquon(i)];
  [[lineButtons cellAt:lj:li] setTitle: texth(i)];
  auxi=1;
return self;
}

- forceRule:sender 
{
char c[20];
int  i, j, k, i0, i1, i2, i3;
  if (lj==0) return self;
  i0=[[lineButtons cellAt:lj-1:(li+40-1)%40] tag];
  i1=[[lineButtons cellAt:lj-1:li] tag];
  i2=[[lineButtons cellAt:lj-1:(li+1)%40] tag];
  i3=[[lineButtons cellAt:lj-1:(li+2)%40] tag];
  j=[[lineButtons cellAt:lj:li] tag];
  ascrule[i0][i1][i2][i3]=j+'0';
  binrule[i0][i1][i2][i3]=j;
  /*k=KK*(KK*i0+i1)+i2;*/
  k=KK*(KK*(KK*i0+i1)+i2)+i3;
  for (i=0; i<KK; i++) [[ascru cellAt: i: k] setIntValue: NO];
  [[ascru cellAt: j: k] setIntValue: YES];
  wrru(c,ascrule);
  [ascru setStringValue: c];
  auxi=1;
return self;
}

- moveCursor:sender 
{
int i;
  i=3*[sender selectedRow]+[sender selectedCol];
  [[lineButtons cellAt:lj:li] setIconPosition: NX_ICONONLY];
  switch (i) {
    case 1: lj=(lj+8-1)%8; break;
    case 3: li=(li+40-1)%40; break;
    case 5: li=(li+1)%40; break;
    case 7: lj=(lj+1)%8; break;
    default: break;};
    [[lineButtons cellAt:lj:li] setIconPosition: NX_TITLEONLY];
return self;

}

- nextCell 
{
  li=(li+1)%40;
return self;
}

- nextState:sender
{int k;
  k=([[sender selectedCell] tag]+1)%KK;
  [[sender selectedCell] setTag:k];
  [[sender selectedCell] setIcon: iquon(k)];
  [[sender selectedCell] setTitle: texth(k)];
return self;
}

- rowGoUp:sender
{int i;
  i=[lineRow selectedRow];
  [lineRow selectCellAt: (i-1)%8: 0];
return self;
}

- rowGoDown:sender
{int i;
  i=[lineRow selectedRow];
  [lineRow selectCellAt: (i+1)%8: 0];
return self;
}

- showCursor:sender 
{
  [[lineButtons cellAt:lj:li] setIconPosition: NX_ICONONLY];
  lj=[sender selectedRow];
  li=[sender selectedCol];  
  [[lineButtons cellAt:lj:li] setIconPosition: NX_TITLEONLY];
  [lineRow selectCellAt:lj:0];
return self;
}

- copyRow:sender
{
int  i, j, k;
char *c;
for (i=0; i<40; i++) {
  j=[lineRow selectedRow];
  if (j==0) return self;
  c=[[lineButtons cellAt:j-1:i] icon];
  [[lineButtons cellAt:j:i] setIcon:c];
  k=[[lineButtons cellAt:j-1:i] tag];
  [[lineButtons cellAt:j:i] setTag:k];
 }
  if ([auShRow state]) [lineRow selectCellAt: (j+1)%8: 0];
  auxi=1;
return self;
}

- protectCell:sender
{
  [[lineButtons cellAt:lj:li] setEnabled: NO];
  [[lineButtons cellAt:lj:li] setBordered: NO];
  [self nextCell];
return self;
}

/* - - - - - - - - - - - -    r o w   e d i t i o n    - - - - - - - - - - - */

- protectRow:sender
{int i, j;
  j=[lineRow selectedRow];
  for (i=0; i<40; i++) {
    [[lineButtons cellAt:j:i] setEnabled: NO];
    [[lineButtons cellAt:j:i] setBordered: NO];
    }
  if ([auShRow state]) [lineRow selectCellAt: (j+1)%8: 0];
return self;
}

- protectRule:sender 
{int i, j, i0, i1, i2, i3;
  if (lj==0) return self;
  i0=[[lineButtons cellAt:lj-1:(li+40-1)%40] tag];
  i1=[[lineButtons cellAt:lj-1:li] tag];
  i2=[[lineButtons cellAt:lj-1:(li+1)%40] tag];
  i3=[[lineButtons cellAt:lj-1:(li+2)%40] tag];
  j=KK*(KK*(KK*i0+i1)+i2)+i3;
  /*j=KK*(KK*i0+i1)+i2;*/
  for (i=0; i<KK; i++) {
    [[ascru cellAt: i: j] setEnabled: NO];
    [[ascru cellAt: i: j] setBordered: NO];
    }
return self;
}

- rowOfRules:sender
{int i, j, k, i0, i1, i2, i3, ll; int c;
printf("hello from rowOfTransitions\n");
  ll=[lineRow selectedRow];
  if (ll>=7) return self;
  for (k=0; k<40; k++) {
       i0=[[lineButtons cellAt: ll: (k+40-1)%40] tag];
       i1=[[lineButtons cellAt: ll:           k] tag];
       i2=[[lineButtons cellAt: ll: (k+40+1)%40] tag];
       i3=[[lineButtons cellAt: ll: (k+40+2)%40] tag];
        c=[[lineButtons cellAt: ll+1: k] tag];
       ascrule[i0][i1][i2][i3]=c+'0';
       auxrule[i0][i1][i2][i3]=1;
       j=KK*(KK*(KK*i0+i1)+i2)+i3;
       /*j=KK*(KK*i0+i1)+i2;*/
      for (i=0; i<KK; i++) {
        [[ascru cellAt: i: j] setIntValue: NO];
        [[ascru cellAt: i: j] setEnabled: NO];
        [[ascru cellAt: i: j] setBordered: NO];
        }
     [[ascru cellAt: c: j] setIntValue: YES];
     }
  auxi=1;
return self;
}

- freeCell:sender
{
  [[lineButtons cellAt:lj:li] setEnabled: YES];
  [[lineButtons cellAt:lj:li] setBordered: YES];
  [self nextCell];
return self;
}

- freeRule:sender 
{int i, j, i0, i1, i2, i3;
  if (lj==0) return self;
  i0=[[lineButtons cellAt:lj-1:(li+40-1)%40] tag];
  i1=[[lineButtons cellAt:lj-1:li] tag];
  i2=[[lineButtons cellAt:lj-1:(li+1)%40] tag];
  i3=[[lineButtons cellAt:lj-1: (li+40+2)%40] tag];
  j=KK*(KK*(KK*i0+i1)+i2)+i3;
  /*j=KK*(KK*i0+i1)+i2;*/
  for (i=0; i<KK; i++) {
    [[ascru cellAt: i: j] setEnabled: YES];
    [[ascru cellAt: i: j] setBordered: YES];
    }
return self;
}

- unitCell:sender
{
  [[lineButtons cellAt:lj:li] setTag: 1];
  [[lineButtons cellAt:lj:li] setIcon: "1cell"];
  [[lineButtons cellAt:lj:li] setTitle: "1"];
  [[lineButtons cellAt:lj:li] setIconPosition: NX_ICONONLY];
  [self nextCell];
  auxi=1;
return self;
}

- zeroCell:sender
{
  [[lineButtons cellAt:lj:li] setTag: 0];
  [[lineButtons cellAt:lj:li] setIcon: "0cell"];
  [[lineButtons cellAt:lj:li] setTitle: "0"];
  [[lineButtons cellAt:lj:li] setIconPosition: NX_ICONONLY];
  [self nextCell];
  auxi=1;
return self;
}


/* unconditional evolution of the line */
- uevLine: sender
{ int i, j, x[KK], lr, nr, nc;
  nr=8;
  nc=40;
  lr=[lineRow selectedRow];
  if (lr==nr-1) return self;
  for (i=0; i<40; i++) {
    [self nhood: x: lr: i: 40];
    j=ascrule[x[0]][x[1]][x[2]][x[3]]-'0';
    [[lineButtons cellAt:lr+1:i] setTag: j];
    [[lineButtons cellAt:lr+1:i] setIcon: iquon(j)];
    [[lineButtons cellAt:lr+1:i] setTitle: texth(j)];
    }
  lr++;
  if ([auShRow state]) [lineRow selectCellAt: (lr)%8: 0];
  auxi=1;
return self; 
}

/* conditional evolution of the line */
- cevLine:sender
{ int i, j, x[KK], lr, nr, nc;
  nr=8;
  nc=40;
  lr=[lineRow selectedRow];
  if (lr==nr-1) return self;
  for (i=0; i<40; i++) {
    if ([self nhood: x: lr: i: 40]) j=KK; else j=ascrule[x[0]][x[1]][x[2]][x[3]]-'0';
    if (auxrule[x[0]][x[1]][x[2]][x[3]]&&j!=[[lineButtons cellAt:lr+1:i] tag]) j=KK;
    [[lineButtons cellAt:lr+1:i] setTag: j];
    [[lineButtons cellAt:lr+1:i] setIcon: iquon(j)];
    [[lineButtons cellAt:lr+1:i] setTitle: texth(j)];
    }
  lr++;
   auxi=1;
 if ([auShRow state]) [lineRow selectCellAt: (lr)%8: 0];
return self; 
}

- (int)nhood:(int *)x:(int)i:(int)j:(int)n
{
int k, l;
  l=NO;
  k=[[lineButtons cellAt:i:(j+n-1)%n] tag];
  x[0]=k; if (k==KK) l=YES;
  k=[[lineButtons cellAt:i:j] tag];
  x[1]=k; if (k==KK) l=YES;
  k=[[lineButtons cellAt:i:(j+1)%n] tag];
  x[2]=k; if (k==KK) l=YES;
  k=[[lineButtons cellAt:i:(j+2)%n] tag];
  x[3]=k; if (k==KK) l=YES;
return l;
}

char *iquon(k) int k; {
  switch (k) {
    case 0: return "0cell"; break;
    case 1: return "1cell"; break;
    case 2: return "kkcell"; break;
    default: return "0cell"; break;}
}

char *texth(k) int k; {
  switch (k) {
    case 0: return "0"; break;
    case 1: return "1"; break;
    case 2: return " "; break;
    default: return "0"; break;}
}

/* - - - - - - -  g e n e r a l   i n i t i a l i z a t i o n   - - - - - - */

- unitRow:sender
{int i, j;
j=[lineRow selectedRow];
for (i=0; i<40; i++) {
  [[lineButtons cellAt:j:i] setTag: 1];
  [[lineButtons cellAt:j:i] setIcon: "1cell"];
  [[lineButtons cellAt:j:i] setTitle: "1"];
  [[lineButtons cellAt:j:i] setIconPosition: NX_ICONONLY];
  }
  if ([auShRow state]) [lineRow selectCellAt: (j+1)%8: 0];
  auxi=1;
return self;
}

- zeroRow:sender
{int i, j;
j=[lineRow selectedRow];
for (i=0; i<40; i++) {
  [[lineButtons cellAt:j:i] setTag: 0];
  [[lineButtons cellAt:j:i] setIcon: "0cell"];
  [[lineButtons cellAt:j:i] setTitle: "0"];
  [[lineButtons cellAt:j:i] setIconPosition: NX_ICONONLY];
  }
  if ([auShRow state]) [lineRow selectCellAt: (j+1)%8: 0];
  auxi=1;
return self;
}

- freeRow:sender
{int i, j;
  j=[lineRow selectedRow];
  for (i=0; i<40; i++) {
    [[lineButtons cellAt:j:i] setEnabled: YES];
    [[lineButtons cellAt:j:i] setBordered: YES];
    }
  if ([auShRow state]) [lineRow selectCellAt: (j+1)%8: 0];
return self;
}


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/*			definition of REC predictes			 */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

int 	rop0() {arr1[llal]=0;}
int 	rop1() {arr1[llal]=1;}
int 	rop2() {arr1[llal]=2;}
int	roppc() {if (random()%1000<500) return False; else return True;}
int	roplr() {if (llal==AL) return False; else {llal++; return True;}}
int	ropll() {if (llal==0) return False; else {llal--; return True;}}
int 	roplz() {llal=0;}


int ropuw()
{char c[10]; int i;
   for (i=0; i<r_pbufl; i++)
      c[i]=r_pbufp[i];
   c[r_pbufl]=0;
   longwolftoasc(c);
   asctobin();
}

  
@end

/* end LinePanel.m */